package drawing;
import com.nttdocomo.ui.*;

class DummySprite implements ISprite{
	public	 boolean isAlive(){return false;}
	public	 void setAlive(boolean f){}

	public int getX(){return 0;}
	public int getY(){return 0;}
	public int getZ(){return 0;}
	public	 void setX(int xx){}
	public	 void setY(int yy){}
	public	 void setZ(int zz){}
	public	 int getWidth(){return 0;}
	public	 int getHeight(){return 0;}
	public	 void reset(){}

	public	 int getId(){return -1;}
		
	public	 boolean isVisible(){return false;}
	public	 void setVisible(boolean vs){}
	public	 boolean isFlipV(){return false;}
	public	 void setFlipV(boolean fl){}
	public	 boolean isFlipH(){return false;}
	public	 void setFlipH(boolean fl){}
	public	 void setImage(ScaledImage img){}

	public	void setSize(int ww,int hh){}
	public	void moveTo(int xx,int yy,int zz){}
	public	void moveTo(int xx,int yy){}
	public	boolean kill(){return false;}
	public	void dispose(){}
	
	public boolean drawingEntry(VGraphics g){g.entry(this);return true;}
	public boolean draw(VGraphics g){
		g.drawString("*SPRITE OVER*",10,10);
		g.drawString("*SPRITE OVER*",10,30);
		g.drawString("*SPRITE OVER*",10,50);
		return true;
	}
	
} //


public  class SpriteFactory{
	private static ISprite[] sprites = new ISprite[128*3];
	private static int ptr = 128*3-1;
	private static ISprite dummy = new DummySprite();

	public static boolean Init(){
		sprites = new ISprite[128*3];
		ptr = sprites.length -1;
		return true;
	}

	public static ISprite getSprite(){
		ISprite ret = findIdle();
		if(ret!=null){
			ret.reset();
			ret.setAlive(true);
			return ret;
		}
			return dummy;
	}

	public static ISprite findIdle(){
		for(int i=sprites.length-1;i>=0;i--){
			ptr = (ptr + 1) % sprites.length;
			ISprite spr = sprites[ptr];
			if( spr == null ){
				spr = new VSprite();
				sprites[ptr] = spr;
//				System.out.println("create " + ptr);
				return spr;
			}
			if( !spr.isAlive() )return spr;
		}
			return dummy;
		}
	}
