/*
 * test2.java
 *
 * DATE : 2007/05/30 12:22
 */
import com.nttdocomo.ui.IApplication;
import com.nttdocomo.ui.Canvas;
import com.nttdocomo.ui.Graphics;
import com.nttdocomo.ui.Frame;
import com.nttdocomo.ui.Display;

import com.nttdocomo.util.Timer;
import com.nttdocomo.util.TimerListener;

/**
 * test2
 *
 * @author NAME
 */
public class test2 extends IApplication {

    public void start() {
        Display.setCurrent((Frame)(new MainCanvas()));
    }

}

/**
 * MainCanvas
 * 
 */
class MainCanvas extends Canvas implements TimerListener{

    MainCanvas() {
        setSoftLabel(SOFT_KEY_1, "END");
        setBackground(Graphics.getColorOfName(Graphics.BLUE));

        Timer tm = new Timer();
        tm.setTime(1000);
        tm.setRepeat(true);
        tm.setListener((TimerListener)this);
        // tm.start();
        
    }

    public void paint(Graphics g) {
        g.lock();
        g.clearRect(0, 0, Display.getWidth(), Display.getHeight());
        g.setColor(Graphics.getColorOfName(Graphics.WHITE));
        g.drawString("Start IApplication", Display.getWidth() / 4, Display.getHeight() / 2);
        g.unlock(true);
    }

    public void processEvent(int type, int param) {
        if (type == Display.KEY_RELEASED_EVENT) {
            if (param == Display.KEY_SOFT1) {
                (IApplication.getCurrentApp()).terminate();
            }
        }
    }

    public void timerExpired(Timer source) {
    }
    
}

