package drawing;
import drawing.*;
	public interface ISprite extends IDrawingEntry{
		 boolean isAlive();
		 void setAlive(boolean f);


		 void setX(int xx);
		 void setY(int yy);
		 void setZ(int zz);
		 int getWidth();
		 int getHeight();
		 void reset();

		 int getId();
		
		 boolean isVisible();
		 void setVisible(boolean vs);
		 boolean isFlipV();
		 void setFlipV(boolean fl);
		 boolean isFlipH();
		 void setFlipH(boolean fl);

		 void setImage(ScaledImage img);

		void setSize(int ww,int hh);
		void moveTo(int xx,int yy,int zz);
		void moveTo(int xx,int yy);
		boolean kill();
		void dispose();
	}
