package input;

import com.nttdocomo.ui.*;

 
public class InputRecorder{
	private static final int cr = 100; // sʒu

//	private int lastInput = 0;
//	private int lastClock = 0;

	private int replayCnt = 0;
	private boolean hasNext = false;
	public boolean isHasNext(){return hasNext;}
	public int getLength(){return replayCnt;}
	private StringBuffer data;

	public InputRecorder(){
		data = new StringBuffer(1024);
	}
	public void reset(){
		replayCnt=0;
		hasNext = false;
		data.setLength(0);
	}

	public int record(IGamePad pad){
		int s = pad.getPadStatus();
		data.append((char)(s + 0x3b));
		replayCnt++;
//		lastInput=s;
//		lastClock=tm;
		return s;
	} //
	public int play(IGamePad pad){
		if(!hasNext)return pad.getPadStatus();
		int t = ((int)data.charAt(replayCnt++) - 0x3b);
		hasNext = (data.length() > replayCnt ) ? true : false;
	 return t;
	} //

	public String getRecordData(){
		data.insert(0,'0');
//		data.unshift(0);

		StringBuffer tmp = new StringBuffer(replayCnt + 1024);
		int i = 0 , chk1 = (int)data.charAt(1), chk2 = 0, cnt = 0;
		// abcdddeeeeecccccc  abcd3e5c6

//		for(; i < replayCnt ; i++){
		for(; i < data.length()-1 ; i++){
			chk2 = ((int)data.charAt( i + 1 ));
			if(chk1 != chk2){// || cnt >= 255){
				if(cnt > 1){
					tmp.append( (char)(chk1) );
					tmp.append( cnt + "" );
//					String.fromCharCode(chk1 + 0x3b) + cnt)
				}
				else{
					tmp.append( (char)(chk1) );
//					tmp.append( String.fromCharCode(chk1 + 0x3b) )
				}
				cnt=1;
				chk1 = chk2;
			}else
				cnt++;
		}
		tmp.append((char)(chk1));//String.fromCharCode(chk1 + 0x3b) + cnt;
		tmp.append( cnt + "" );
					
		data.deleteCharAt(0);
//		data.shift();

		StringBuffer tmp2 = new StringBuffer(tmp.length()+1024);//.join(""),ret="";
		for(i = 0; i < tmp.length() ; i += cr ) {
			int crr = i+cr;if(crr> tmp.length())crr = tmp.length();
			for(int j=i;j<crr;j++)tmp2.append(tmp.charAt(j));
//			tmp2.append(tmp2.substring(i,cr));
			tmp2.append("\n");
		}
//		System.out.println("compressed:\n" + tmp2.toString());
		return tmp2.toString();
	} //

	public void setRecordData(String code){
//		StringBuffer data = new StringBuffer();//Array();
//		data.replace
//		var dat = code.replace(/[\t\r\n ]/g,'');
//		String  tmp = ;
		data.setLength(0);
		data.append(decompress(code));
//		System.out.println("decompressed:\n" + data.toString());
//		for(int i = 0 ; i < tmp.length ; i++ )data.append(tmp.charAt(i));
		hasNext = true;
	} //

	public static String decompress(String txt){
		StringBuffer tmp = new StringBuffer();
		StringBuffer len = new StringBuffer(10);
		int current = 0;
		// abcd3e5c6  abcdddeeeeecccccc
		for( int i = 0; i < txt.length() ; i++){
			int c = (int)txt.charAt(i);

			if( c == (int)'\n' || c == (int)'\r' || 
				c == (int)'\t' || c == (int)' ')continue;

			if( (c >= 0x40 && c<= 0xff) || (c >= 0x100 && c <= 0x140)){
				if(len.length() > 0){
					int clen = Integer.parseInt(len.toString(),10) -1;
					for(int j=0;j<clen;j++)tmp.append((char)current);
				}
				current = c;
				tmp.append((char)c);
				len.setLength(0);
			}else
			if( c >= (int)'0' && c<= (int)'9'){
				len.append((char)c);
			}

		}
				if(len.length() > 0){
					int clen = Integer.parseInt(len.toString(),10) -1;
					for(int j=0;j<clen;j++)tmp.append((char)current);
				}
//		txt = txt.replace(/([\x40-\xff\x0100-0140])([0-9]+)/g,
//					function(a,b,c){return ch[b.charCodeAt(0)].substring(0,c)} );
		return tmp.toString();
	} //

} //


